VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cListColumns"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'  FILE:        cListColumns.cls
'               Microsoft TPC-H Kit Ver. 2.7.0-1005
'               Copyright Microsoft, 2008
'               All Rights Reserved
'
'
'  PURPOSE:     Maintains arrays of the columns in the list view for
'               each of the different nodes that are displayed, viz.
'               steps, parameters, connections, etc.
'  Contact:     Reshma Tharamal (reshmat@microsoft.com)
'
Option Explicit

Private Const mlIndex As Integer = 1

Public Enum ColType
    StepProperties = mlIndex
    Parameter
    StepRun
    Connection
    ConnectionString
    Others
End Enum

Public Enum ColStepRun
    RunDescription = mlIndex
    RunLabel
    RunText
    Status
    StartTime
    EndTime
    Elapsed
    IteratorName
    IteratorValue
End Enum

Public Enum ColParameter
    Name = mlIndex
    Value
    ParamDescription
End Enum

Public Enum ColConnection
    ConnName = mlIndex
    ConnectionStringName
    ConnectionType
End Enum

Public Enum ColConnectionString
    ConnStrName = mlIndex
    ConnStrValue
    ConnStrDescription
End Enum

Public Enum ColStepView
    Description = mlIndex
    Label
    file
    Text
    Processes
End Enum

Public Enum ColOthers
    Nodes = mlIndex
End Enum

Private marrColumns() As New cListColumn
Private mlBounds(ColType.StepProperties To ColType.Others) As Long
Public Function Item(ByVal x As ColType, ByVal y As Integer) As cListColumn
Attribute Item.VB_UserMemId = 0
    Set Item = marrColumns(x, y)
End Function
Public Function lIndex(ByVal x As ColType) As Long
    lIndex = mlIndex
End Function
Public Function HIndex(ByVal x As ColType) As Long
    HIndex = mlBounds(x)
End Function

Public Function SettingSaved(iType As ColType) As Boolean
    SettingSaved = (marrColumns(iType, mlIndex).ColWidth <> 0)
End Function
Private Sub Class_Initialize()

    ReDim Preserve marrColumns(ColType.StepProperties To ColType.Others, mlIndex To IteratorValue)

    mlBounds(StepRun) = IteratorValue
    marrColumns(StepRun, RunDescription).ColName = "Description"
    marrColumns(StepRun, RunLabel).ColName = "Step Label"
    marrColumns(StepRun, RunText).ColName = "Step Text/File"
    marrColumns(StepRun, Status).ColName = "Status"
    marrColumns(StepRun, StartTime).ColName = "Start Time"
    marrColumns(StepRun, EndTime).ColName = "End Time"
    marrColumns(StepRun, Elapsed).ColName = "Elapsed Time"
    marrColumns(StepRun, IteratorName).ColName = "Iterator Name"
    marrColumns(StepRun, IteratorValue).ColName = "Iterator Value"
    
    mlBounds(Parameter) = ParamDescription
    marrColumns(Parameter, Name).ColName = "Parameter Name"
    marrColumns(Parameter, Value).ColName = "Value"
    marrColumns(Parameter, ParamDescription).ColName = "Description"
        
    mlBounds(StepProperties) = Processes
    marrColumns(StepProperties, Description).ColName = "Description"
    marrColumns(StepProperties, Label).ColName = "Step Label"
    marrColumns(StepProperties, file).ColName = "Text File Name"
    marrColumns(StepProperties, Text).ColName = "Step Text"
    marrColumns(StepProperties, Processes).ColName = "Processes"
    
    mlBounds(Connection) = ConnectionType
    marrColumns(Connection, ConnName).ColName = "Connection Name"
    marrColumns(Connection, ConnectionStringName).ColName = "Connection String"
    marrColumns(Connection, ConnectionType).ColName = "Connection Type"
    
    mlBounds(ConnectionString) = ConnStrDescription
    marrColumns(ConnectionString, ConnStrName).ColName = "Connection String Name"
    marrColumns(ConnectionString, ConnStrValue).ColName = "Connection String"
    marrColumns(ConnectionString, ConnStrDescription).ColName = "Description"
    
    mlBounds(Others) = Nodes
    marrColumns(Others, Nodes).ColName = "Nodes"
    
End Sub

Private Sub Class_Terminate()

ReDim marrColumns(ColType.StepProperties To ColType.Others, mlIndex)

End Sub


